import pyxel
import time
 
MAX_SPEED = 1
BOARD = 120
DASHTIME = 5
COOLDOWN = 48

def draw_board():
    pyxel.circ(128,128,BOARD, 7)

class Player:
    def __init__(self):
        self.x = 64
        self.y = 64
        self.dx = 0
        self.dy = 0
        self.isAlive = True
        self.isDashing = False
        self.dashtime = 0
        self.dashd = [0, 0]
        self.movUp = False
        self.movDown = False
        self.movLeft = False
        self.movRight = False
        self.cooldown = 0
        self.isbeingpushed = False
    
    def update(self):
        isMoving = 0
        if pyxel.btn(pyxel.KEY_UP):
            self.movUp = True
            isMoving = 1
            self.dashd[1] = -5
            if self.dy > -MAX_SPEED:
                self.dy -= 0.1
        else:
           self.movUp = False 
        if pyxel.btn(pyxel.KEY_DOWN):
            self.movDown = True
            isMoving = 1
            self.dashd[1] = 5
            if self.dy < MAX_SPEED:
                self.dy += 0.1
        else:
           self.movDown = False
        if pyxel.btn(pyxel.KEY_LEFT):
            self.movLeft = True
            isMoving = 1
            self.dashd[0] = -5
            if self.dx > -MAX_SPEED:
                self.dx -= 0.1
        else:
           self.movLeft = False
        if pyxel.btn(pyxel.KEY_RIGHT):
            self.movRight = True
            isMoving = 1
            self.dashd[0] = 5
            if self.dx < MAX_SPEED:
                self.dx += 0.1
        else:
           self.movRight = False
        if isMoving == 0:
            if self.dx > 0:
                self.dx -= 0.1
            if self.dx < 0:
                self.dx += 0.1
            if self.dy > 0:
                self.dy -= 0.1
            if self.dy < 0:
                self.dy += 0.1
            if (self.dx < 0.1 and self.dy > -0.1) and (self.dy < 0.1 and self.dy > -0.1):
                self.dx = 0
                self.dy = 0

        if not self.isDashing:
            self.x += self.dx
            self.y += self.dy

        #ACTIONS
        if pyxel.btn(pyxel.KEY_E) and self.cooldown == 0:
            self.isDashing = True
            self.dashtime = DASHTIME
            self.cooldown = COOLDOWN

        if self.isDashing:
            self.x += self.dashd[0]
            self.y += self.dashd[1]
            self.dashtime -= 1
            if self.dashtime == 0:
                self.isDashing = False
                self.dashd = [0, 0]
        elif isMoving == 0:
            self.dashd = [0, 0]

        if self.cooldown > 0:
            self.cooldown -= 1


        #COLLISION
        if self.isDashing:
            for enemie in enemies:
                dist = pyxel.sqrt(pow(self.x - enemie.x, 2) + pow(self.y - enemie.y, 2))
                #print(pyxel.sqrt(pow(self.x - enemie.x, 2) + pow(self.y - enemie.y, 2)))
                if dist < 10 and enemie.isPushed == False:
                    enemie.isPushed = True
                    enemie.dx *= -40
                    enemie.dy *= -40
                    print(enemie.dx)
                    print(enemie.dy)
        if(self.x < 0 or self.x > 128) or (self.y < 0 or self.y > 128):
            self.isAlive = False
            pyxel.load('theme.pyxres')
            pyxel.bltm(0,0,0,0,128,128,128)
            pyxel.quit()
            
        


        
    def draw(self):
        pyxel.load('theme.pyxres')
        if self.movUp:
            pyxel.blt(self.x, self.y, 0, 104, 160, 16, 16, 7)
        elif self.movDown:
            pyxel.blt(self.x, self.y, 0, 120, 160, 16, 16, 7)
        elif self.movLeft:
            pyxel.blt(self.x, self.y, 0, 120, 144, 16, 16, 7)
        elif self.movRight:
            pyxel.blt(self.x, self.y, 0, 104, 144, 16, 16, 7)
        else:
            pyxel.blt(self.x, self.y, 0, 104, 160, 16, 16, 7)


class Enemie:
    def __init__(self, x, y, type):
        self.dx = 0
        self.dy = 0
        self.x = x
        self.y = y
        self.isPushed = False
        self.type = type
        self.isAlive = True

    def update(self):
        if self.type == 0:
            if not self.isPushed:
                vx = self.x - player.x
                vy = self.y - player.y
                if vx > 0:
                    self.dx = -0.5
                else:
                    self.dx = 0.5
                if vy > 0:
                    self.dy = -0.5
                else:
                    self.dy = 0.5
                self.x += self.dx
                self.y += self.dy
                if not player.isDashing:
                    dist = pyxel.sqrt(pow(self.x - player.x, 2) + pow(self.y - player.y, 2))
                    #print(pyxel.sqrt(pow(self.x - player.x, 2) + pow(self.y - player.y, 2)))
                    if dist < 7 and not player.isbeingpushed:
                        player.isbeingpushed = True
                        player.dx += 1
                        player.dy += 1
                        player.dx *= -1.5
                        player.dy *= -1.5
                    elif dist < 7:
                        player.isbeingpushed = False
            else:
                self.dx = self.dx/1.5
                self.dy = self.dy/1.5

                self.x += self.dx
                self.y += self.dy

                if (self.dx < 0.5 and self.dx > -0.5) and (self.dy < 0.5 and self.dy > -0.5):
                    self.isPushed = False
        if(self.x < 0 or self.x > 128) or (self.y < 0 or self.y > 128):
            self.isAlive = False
            enemies.remove(self)

    def draw(self):
        pyxel.load('theme.pyxres')
        if self.dy < 0:
            pyxel.blt(self.x, self.y, 0, 32, 0, 16, 16, 7)
        elif self.dy > 0:
            pyxel.blt(self.x, self.y, 0, 48, 0, 16, 16, 7)
        elif self.dx < 0:
            pyxel.blt(self.x, self.y, 0, 16, 0, 16, 16, 7)
        elif self.dx > 0:
            pyxel.blt(self.x, self.y, 0, 0, 0, 16, 16, 7)
        else:
            pyxel.blt(self.x, self.y, 0, 0, 0, 16, 16, 7)

class App:
    def __init__(self):
        pyxel.init(128, 128, fps=24)
        self.x = 0
        enemies.append(Enemie(110, 110, 0))
        enemies.append(Enemie(10, 110, 0))
        enemies.append(Enemie(110, 10, 0))
        pyxel.run(self.update, self.draw)

    def update(self):
        player.update()
        for en in enemies:
            en.update()

    def draw(self):
        pyxel.cls(0)
        #pyxel.load('images.pyxres', True, True, False, False)
        pyxel.bltm(0,0,0,0,0,128,128)
        player.draw()
        for en in enemies:
            en.draw()

player = Player()

enemies = []

App()
